logging.h File Reference

Implementation of logging methods. More...

`#include <glib.h>`

Go to the source code of this file.

## Functions

GSList * | load_log_configuration (gchar *)
| Loads parameters from a config file into a linked list. More...
void | free_log_configuration (GSList *)
| Frees all resources loaded by the config loader. More...
gchar * | get_time (gchar *)
| Returns time as specified in time_fmt strftime format. More...
void | gvm_log_silent (const char *, GLogLevelFlags, const char *, gpointer)
| Returns immediately. More...
void | gvm_log_func (const char *, GLogLevelFlags, const char *, gpointer)
| Creates the formatted string and outputs it to the log destination. More...
void | log_func_for_gnutls (int, const char *)
| This function logs debug messages from gnutls. More...
int | setup_log_handlers (GSList *)
| Sets up routing of logdomains to log handlers. More...
void | gvm_log_lock (void)
| Try to lock logger_mutex. More...
void | gvm_log_unlock (void)
| Unlock logger_mutex. More...

## Detailed Description

Implementation of logging methods.

## Function Documentation

## free_log_configuration()

void free_log_configuration | ( | GSList * | log_domain_list | ) |

Frees all resources loaded by the config loader.

Parameters

  log_domain_list | Head of the link list.

## get_time()

gchar* get_time | ( | gchar * | time_fmt | ) |

Returns time as specified in time_fmt strftime format.

Parameters

  time_fmt | ptr to the string format to use. The strftime man page documents the conversion specification. An example time_fmt string is "%Y-%m-%d %H:%M:%S".

Returns
  NULL in case the format string is NULL. A ptr to a string that contains the formatted date time value. This value must be freed using glib's g_free.

## gvm_log_func()

void gvm_log_func | ( | const char * | log_domain,
|  | GLogLevelFlags | log_level,
|  | const char * | message,
|  | gpointer | gvm_log_config_list
| ) |  |

Creates the formatted string and outputs it to the log destination.

Parameters

  log_domain | A string containing the message's log domain.
  log_level | Flags defining the message's log level.
  message | A string containing the log message.
  gvm_log_config_list | A pointer to the configuration linked list.

## gvm_log_lock()

void gvm_log_lock | ( | void |  | ) |

Try to lock logger_mutex.

## gvm_log_silent()

void gvm_log_silent | ( | const char * | log_domain,
|  | GLogLevelFlags | log_level,
|  | const char * | message,
|  | gpointer | gvm_log_config_list
| ) |  |

Returns immediately.

Parameters

  log_domain | A string containing the message's log domain.
  log_level | Flags defining the message's log level.
  message | A string containing the log message.
  gvm_log_config_list | A pointer to the configuration linked list.

## gvm_log_unlock()

void gvm_log_unlock | ( | void |  | ) |

Unlock logger_mutex.

## load_log_configuration()

GSList* load_log_configuration | ( | gchar * | config_file | ) |

Loads parameters from a config file into a linked list.

Parameters

  config_file | A string containing the path to the configuration file to load.

Returns
  NULL in case the config file could not be loaded or an error occurred otherwise, a singly linked list of parameter groups is returned.

## log_func_for_gnutls()

void log_func_for_gnutls | ( | int | level,
|  | const char * | message
| ) |  |

This function logs debug messages from gnutls.

Parameters

  level | GnuTLS log level (integer from 0 to 99 according to GnuTLS documentation.
  message | GnuTLS log message.

To enable GNUTLS debug messages, the environment variable `OPENVAS_GNUTLS_DEBUG` is to be set to the desired log level as described in the GNUTLS manual.

## setup_log_handlers()

int setup_log_handlers | ( | GSList * | gvm_log_config_list | ) |

Sets up routing of logdomains to log handlers.

Iterates over the link list and adds the groups to the handler.

Parameters

  gvm_log_config_list | A pointer to the configuration linked list.

Returns
  0 on success, -1 if not able to create log file directory or open log file for some domain.